ON_Font Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_font.h>`

Inheritance diagram for ON_Font:

## Public Types

enum | { face_name_size = 65, bold_weight = 700, medium_weight = 500, normal_weight = 400, light_weight = 300, default_charset = 1, symbol_charset = 2, normal_font_height = 256 }

## Public Member Functions

| ON_Font ()
| ~ON_Font ()
bool | CreateFontFromFaceName (const wchar_t *face_name, bool bBold, bool bItalic)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON_UUID | ModelObjectId () const
void | SetFontName (const wchar_t *)
void | SetFontName (const char *)
void | GetFontName (ON_wString &) const
const wchar_t * | FontName () const
void | SetFontIndex (int)
int | FontIndex () const
double | LinefeedRatio () const
void | SetLinefeedRatio (double linefeed_ratio)
bool | SetFontFaceName (const wchar_t *)
bool | SetFontFaceName (const char *)
void | GetFontFaceName (ON_wString &) const
const wchar_t * | FontFaceName () const
int | FontWeight () const
void | SetFontWeight (int)
bool | IsItalic () const
void | SetIsItalic (bool)
void | SetItalic (bool)
bool | IsBold () const
void | SetBold (bool)
bool | IsUnderlined () const
void | SetUnderlined (bool)
void | Defaults ()
int | HeightOfI () const
int | HeightOfLinefeed () const
double | AscentRatio () const
bool | CompareFontCharacteristics (ON_Font &font_to_compare, bool bCompareName) const
void | UpdateImplementationSettings ()
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON::object_type | ObjectType () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static bool | IsSymbolFontFaceName (const wchar_t *facename)

## Public Attributes

ON_wString | m_font_name
int | m_font_weight
bool | m_font_italic
bool | m_font_underlined
double | m_linefeed_ratio
int | m_font_index
ON_UUID | m_font_id
wchar_t | m_facename [face_name_size]

## Static Public Attributes

static const double | m_default_linefeed_ratio
static const int | m_metrics_char

## Detailed Description

Definition at line 20 of file opennurbs_font.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
face_name_size |
bold_weight |
medium_weight |
normal_weight |
light_weight |
default_charset |
symbol_charset |
normal_font_height |

Definition at line 99 of file opennurbs_font.h.

## Constructor & Destructor Documentation

## ON_Font()

ON_Font::ON_Font | ( |  | ) |

## ~ON_Font()

ON_Font::~ON_Font | ( |  | ) |

## Member Function Documentation

## AscentRatio()

double ON_Font::AscentRatio | ( |  | ) | const

## CompareFontCharacteristics()

bool ON_Font::CompareFontCharacteristics | ( | ON_Font & | font_to_compare,
|  | bool | bCompareName
| ) |  | const

## CreateFontFromFaceName()

bool ON_Font::CreateFontFromFaceName | ( | const wchar_t * | face_name,
|  | bool | bBold,
|  | bool | bItalic
| ) |  |

## Defaults()

void ON_Font::Defaults | ( |  | ) |

## Dump()

void ON_Font::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## FontFaceName()

const wchar_t* ON_Font::FontFaceName | ( |  | ) | const

## FontIndex()

int ON_Font::FontIndex | ( |  | ) | const

## FontName()

const wchar_t* ON_Font::FontName | ( |  | ) | const

## FontWeight()

int ON_Font::FontWeight | ( |  | ) | const

## GetFontFaceName()

void ON_Font::GetFontFaceName | ( | ON_wString & |  | ) | const

## GetFontName()

void ON_Font::GetFontName | ( | ON_wString & |  | ) | const

## HeightOfI()

int ON_Font::HeightOfI | ( |  | ) | const

## HeightOfLinefeed()

int ON_Font::HeightOfLinefeed | ( |  | ) | const

## IsBold()

bool ON_Font::IsBold | ( |  | ) | const

## IsItalic()

bool ON_Font::IsItalic | ( |  | ) | const

## IsSymbolFontFaceName()

static bool ON_Font::IsSymbolFontFaceName | ( | const wchar_t * | facename | ) |

static

## IsUnderlined()

bool ON_Font::IsUnderlined | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Font::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## LinefeedRatio()

double ON_Font::LinefeedRatio | ( |  | ) | const

## ModelObjectId()

ON_UUID ON_Font::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## Read()

ON_BOOL32 ON_Font::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## SetBold()

void ON_Font::SetBold | ( | bool |  | ) |

## SetFontFaceName() [1/2]

bool ON_Font::SetFontFaceName | ( | const wchar_t * |  | ) |

## SetFontFaceName() [2/2]

bool ON_Font::SetFontFaceName | ( | const char * |  | ) |

## SetFontIndex()

void ON_Font::SetFontIndex | ( | int |  | ) |

## SetFontName() [1/2]

void ON_Font::SetFontName | ( | const wchar_t * |  | ) |

## SetFontName() [2/2]

void ON_Font::SetFontName | ( | const char * |  | ) |

## SetFontWeight()

void ON_Font::SetFontWeight | ( | int |  | ) |

## SetIsItalic()

void ON_Font::SetIsItalic | ( | bool |  | ) |

## SetItalic()

void ON_Font::SetItalic | ( | bool |  | ) |

## SetLinefeedRatio()

void ON_Font::SetLinefeedRatio | ( | double | linefeed_ratio | ) |

## SetUnderlined()

void ON_Font::SetUnderlined | ( | bool |  | ) |

## UpdateImplementationSettings()

void ON_Font::UpdateImplementationSettings | ( |  | ) |

## Write()

ON_BOOL32 ON_Font::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_default_linefeed_ratio

const double ON_Font::m_default_linefeed_ratio

static

Definition at line 150 of file opennurbs_font.h.

## m_facename

wchar_t ON_Font::m_facename[face_name_size]

Definition at line 262 of file opennurbs_font.h.

## m_font_id

ON_UUID ON_Font::m_font_id

Definition at line 261 of file opennurbs_font.h.

## m_font_index

int ON_Font::m_font_index

Definition at line 260 of file opennurbs_font.h.

## m_font_italic

bool ON_Font::m_font_italic

Definition at line 257 of file opennurbs_font.h.

## m_font_name

ON_wString ON_Font::m_font_name

Definition at line 255 of file opennurbs_font.h.

## m_font_underlined

bool ON_Font::m_font_underlined

Definition at line 258 of file opennurbs_font.h.

## m_font_weight

int ON_Font::m_font_weight

Definition at line 256 of file opennurbs_font.h.

## m_linefeed_ratio

double ON_Font::m_linefeed_ratio

Definition at line 259 of file opennurbs_font.h.

## m_metrics_char

const int ON_Font::m_metrics_char

static

Definition at line 153 of file opennurbs_font.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_font.h